//* ------------ Типы данных ------------
// В JavaScript есть 8 основных типов

//* Number
// Представляет как целочисленные значения, так и числа с плавающей точкой
// Кроме обычных чисел, существуют так называемые «специальные числовые значения», которые относятся к этому типу данных: Infinity, -Infinity и NaN
// Infinity представляет собой математическую бесконечность (получить его в результате деления на ноль 1 / 0)
// NaN означает вычислительную ошибку. Это результат неправильной или неопределённой математической операции

//* BigInt
// Возможность работать с целыми числами произвольной длины
// Чтобы создать значение типа BigInt, необходимо добавить n в конец числового литерала (const bigInt = 1234567890123456789012345678901234567890n)

//* String
// Cтрока. Любой текст, который мы записываем или передаем.

//* Boolean
// Булевый тип (логический). true / false

//* Null
// Это просто специальное значение, которое представляет собой «ничего», «пусто» или «значение неизвестно»

//* Undefined
// Если переменная объявлена, но ей не присвоено никакого значения, то её значением будет undefined

//* Symbol
// symbol(символ) используется для создания уникальных идентификаторов в объектах

//* Object
// Тип object (объект) – особенный, все остальные типы называются «примитивными», потому что их значениями могут быть только простые значения (будь то строка, или число, или что-то ещё). В объектах же хранят коллекции данных или более сложные структуры.

//* Оператор typeof
// Позволяет нам увидеть, какой тип данных сохранён в переменной


//* ------------ Преобразование типов ------------

// "" + 1 + 0 = "10" // (1)
// "" - 1 + 0 = -1 // (2)
// true + false = 1
// 6 / "3" = 2
// "2" * "3" = 6
// 4 + 5 + "px" = "9px"
// "$" + 4 + 5 = "$45"
// "4" - 2 = 2
// "4px" - 2 = NaN
// 7 / 0 = Infinity
// "  -9  " + 5 = "  -9  5" // (3)
// "  -9  " - 5 = -14 // (4)
// null + 1 = 1 // (5)
// undefined + 1 = NaN // (6)
// " \t \n" - 2 = -2 // (7)

// Сложение со строкой "" + 1 преобразует 1 к строке: "" + 1 = "1", и в следующем случае "1" + 0 работает то же самое правило.
// Вычитание - (как и большинство математических операторов) работает только с числами, пустая строка "" приводится к 0.
// Сложение со строкой превращает число 5 в строку и добавляет к строке.
// Вычитание всегда преобразует к числу, значит строка " -9 " становится числом -9 (пробелы по краям обрезаются).
// null становится 0 после численного преобразования.
// undefined становится NaN после численного преобразования.
// Пробельные символы, такие как \t и \n, по краям строки игнорируются при преобразовании в число, так что строка " \t \n", аналогично пустой строке, становится 0 после численного преобразования.

//* Number(value)
// Number(NaN) // => NaN
// Number(undefined) // => NaN
// Number(null) // => 0
// Number(true) // => 1
// Number('123') // => 123
// Number(' 123 ') // => 123
// Number('123fff') // => NaN
// Number('zd123') // => NaN

//* Boolean(value)
// Boolean(0) // false
// Boolean(NaN) // false
// Boolean(null) // false
// Boolean(undefined) // false
// Boolean("") // false